//=============================================================================
// BattleSystem.h
//=============================================================================
#pragma once

class CField;
class CManipulator;
class CDisplayManager;
class CCharacter;
class CEnemy;
//-----------------------------------------------------------------------------
// CBattleSystem
//-----------------------------------------------------------------------------
class CBattleSystem
{
private:
	CBattleSystem(void);
	virtual ~CBattleSystem(void);

protected:
	CField			*m_pField;			// tB[hEn`
	CDisplayManager	*m_pDisplayMan;		// \}l[W
	CManipulator	*m_pManipulator;	// Ǘ

	// v[p[eB[
	CCharacter	*m_pPlayerParty[BATTLE_CHAR_COUNT_MAX];

	// Gp[eB[
	int		m_nEnemyCount;
	CEnemy	*m_pEnemyParty[BATTLE_ENEMY_COUNT_MAX];

public:
	static CBattleSystem *GetInstance( void );

	BOOL Initialize( void );	// 
	void FrameMove( void );		// XV
	void Render( void );		// `

	// Debug
	void Debug_SetupPartyInfo( CCharacter **m_pPlayerParty );
	void Debug_SetupEnemyInfo( CEnemy **m_pEnemyParty );

};
