//=============================================================================
// DisplayManager.cpp
//=============================================================================
#include "Stdinc.h"
#include "BattleSystem.h"
#include "DisplayManager.h"
#include "EnemyPartyWindow.h"
#include "PlayerPartyWindow.h"
#include "Field.h"
#include "Enemy.h"
//-----------------------------------------------------------------------------
// RXgN^
//-----------------------------------------------------------------------------
CDisplayManager::CDisplayManager(void)
	:m_pPartyWnd( NULL ), m_pEnemyPtWnd( NULL )

{

}
//-----------------------------------------------------------------------------
// fXgN^
//-----------------------------------------------------------------------------
CDisplayManager::~CDisplayManager(void)
{
	if ( m_pEnemyPtWnd )
	{
		delete m_pEnemyPtWnd;
	}
	if ( m_pPartyWnd )
	{
		delete m_pPartyWnd;
	}
}
//-----------------------------------------------------------------------------
// Initialize
// 
//-----------------------------------------------------------------------------
BOOL CDisplayManager::Initialize( CCharacter **pPlayerParty, CEnemy **pEnemyParty, int nEnemyCount, CField *pField )
{
	// Qƃ|C^ۑ
	m_pField = pField;

	memcpy( m_pEnemyParty, pEnemyParty, sizeof(m_pEnemyParty) );
	m_nEnemyCount = nEnemyCount;

#if 0
	// eXgEBhE
	m_pTestMsg = new CMsgWindow(); 
	m_pTestMsg->Create( 10/*X*/, 10/*Y*/, 620/**/, 440/**/ );
	m_pTestMsg->SetMessage("eXgS");
	m_lstWnd.push_back( m_pTestMsg );
//#else
	// eXgEBhE
	m_pTestMsg = new CMsgWindow(); 
	m_pTestMsg->Create( 0/*X*/, 170/*Y*/, 130/**/, 70/**/ );
	m_pTestMsg->SetMessage("WString|C^Ă镶 ColorFŕ`悵܂ sюQƕʒui߂");
	m_lstWnd.push_back( m_pTestMsg );
#else

	// Gp[eB\EBhE
	m_pEnemyPtWnd = new CEnemyPartyWindow();
	m_pEnemyPtWnd->Create( 0/*X*/, 170/*Y*/, 130/**/, 70/**/, pEnemyParty, nEnemyCount );
	m_lstWnd.push_back( m_pEnemyPtWnd );

	// p[eB\EBhE
	m_pPartyWnd = new CPlayerPartyWindow();
	m_pPartyWnd->Create( 130/*X*/, 170/*Y*/, 190/**/, 70/**/, pPlayerParty );
	m_lstWnd.push_back( m_pPartyWnd );

	// ANeBuEBhE
	m_pActiveWnd = m_pPartyWnd;

#endif
	return TRUE;
}
//-----------------------------------------------------------------------------
// FrameMove
// XV
//-----------------------------------------------------------------------------
void CDisplayManager::FrameMove( void )
{
	// Gp[eBXgXV
	m_pEnemyPtWnd->FrameMove();
}
//-----------------------------------------------------------------------------
// Render
// ZI[_[`
//-----------------------------------------------------------------------------
void CDisplayManager::Render( void )
{
	using namespace std;

	// wi`
	m_pField->Render();

	// G`
	for ( int iCnt = 0; iCnt < m_nEnemyCount; iCnt ++ )
	{
		m_pEnemyParty[iCnt]->Render();
	}

	// EBhE`
	list<CFrameWindow *>::iterator it = m_lstWnd.begin();
	while( it != m_lstWnd.end() )
	{
		(*it)->Render();
		++it;
	}
}
